Unit ASK7C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AR01C_p, AR02C_p, ASK4C_p;

procedure ASK7C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer;
                L :Integer; K :Integer);

implementation

procedure ASK7C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer;
                L :Integer; K :Integer);
var
I,I1,I2,ML :Integer;
PII,RK :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2;
begin

{  ****************************************************************** C }
{                                                                     C }
{  ------------------------  HAHAEHE  ---------------------------- C }
{                                                                     C }
{       PEEHE CCTEM HEHX AEPAECKX YPABHEH  A X = B    C }
{       C KETOHO-PKYHTHO MATPE , BCE KETK KOTOPO CYT    C }
{       KETOHO - PKYHTHE MATP C PKYHTHM KETKAM      C }
{       ( T.E. A - TPEXYPOBHEBA MATPA  CCC-TA ) .                C }
{                                                                     C }
{       OPOHOE OCAHE :                                          C }
{       ( 1 ) E.E.TPTHKOB , O PEEH CCTEM C MATPAM TA     C }
{       TEEBX , B C. CEHH AHA HA OPTPAHE               C }
{       ( BCTEHE METO  HCTPYMEHTAHE CCTEM )  ,       C }
{       -BO MY , 1978 .                                           C }
{                                                                     C }
{                                                                     C }
{  ---------------------------  METO  ------------------------------ C }
{                                                                     C }
{       MATPA  A  KETOHOO PAMEPA  K * K , C KETKAM PAMEPA    C }
{       ( M*L ) * ( M*L ) , OOHM PEOPAOBAHEM PBOTC K     C }
{       KETOHO - AOHAHO MATPE TEX E PAMEPOB .TEM CAMM    C }
{       PEEHE CXOHO CCTEM C TPEXYPOBHEBO MATPE  CCC-TA   C }
{       ( OPKA  M*L*K ) CBEEHO K PEEH   K   CCTEM C BYX-     C }
{       YPOBHEBM MATPAM  CC-TA ( OPKA  M*L ) .              C }
{                                                                     C }
{                                                                     C }
{  ------------------  K  POPAMMPOBAH  ---------------------- C }
{                                                                     C }
{       OPTPAH                                                       C }
{                                                                     C }
{                                                                     C }
{  -----------------  OPAHA - PAPAOTK  -------------------- C }
{                                                                     C }
{       HAYHO - CCEOBATECK BCTEH EHTP  M  Y ,      C }
{       AOPATOP  CEHHOO  AHAA                              C }
{                                                                     C }
{       APEC :                                                       C }
{       MOCKBA ,117234 , HB MY , AOPATOP CEHHOO AHAA    C }
{                                                                     C }
{  -----------------------  COOBAHE  -------------------------- C }
{                                                                     C }
{       CALL ASK7C(A,X,R,M,L,K)                                       C }
{                                                                     C }
{  -------------------------  APAMETP  ---------------------------- C }
{                                                                     C }
{       A - KOMEKCH OHOMEPH MACCB H  M * L , B KOTOPOM    C }
{           AAETC MATPA CCTEM COACHO PABAM , AHHM B     C }
{           ( 1 ) . A MEHHO : B MACCBE  A  ACBAETC EPBA      C }
{           CTPOKA CXOHO MATP .                                 C }
{                                                                     C }
{       X - KOMEKCH OHOMEPH MACCB H  M*L*K , B KOTOPOM    C }
{           AAETC PABA ACT . HA BXOE OPOPAMM B  X       C }
{           OYAETC PEEHE .                                      C }
{                                                                     C }
{       R - KOMEKCH OHOMEPH PAO MACCB H MAX(M,L,K).   C }
{       M - OPOK 3 - O YPOBH . T : E.                      C }
{                                                                     C }
{                                                                     C }
{       L - OPOK 2 - O YPOBH . T : E.                      C }
{                                                                     C }
{       K - OPOK 1 - O YPOBH . T : E.                      C }
{                                                                     C }
{                                                                     C }
{  -----------------  BBAEME  OPOPAMM  --------------------- C }
{                                                                     C }
{       AR01C , AR02C , ASK4C , ASC0C .                               C }
{                                                                     C }
{  ****************************************************************** C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{                                                                     C }

{       SYS003=6.2831853717958647692528 ( 2 *  ) }


PII := SYS003/K;
ML := M*L;

AR01C(A,R,ML,K,PII);
AR02C(X,R,ML,K,PII);

for I:=1 to K do
 begin
_1:
  ASK4C(A[0+0*M+(I-1)*M*L],X[0+0*M+(I-1)*M*L],R,M,L);
 end;

AR01C(X,R,ML,K,PII);

RK := 1.0/K;
for I2:=1 to K do
 begin
  for I1:=1 to L do
   begin
    for I:=1 to M do
     begin
_2:
      X[(I-1)+(I1-1)*M+(I2-1)*M*L] := MulC(X[(I-1)+(I1-1)*M+(I2-1)*M*L],Cmplx(RK,0.0));
     end;
   end;
 end;

end;

end.
